(provide "key-chord")
(in-package "editor")

(defun key-chord-version nil
  (interactive)
  (and (interactive-p)
       (message "key-chord lapse ~A on 2009-01-03 18:52" (key-chord-version)))
  "001")

#| key-chord for xyzzy-0.2.2.235

Copyright (c) 2009 knenet \kneneglect_std(^o^)yahoo.co.jp/

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

MITCZXłB҂𖾂炩ɂΓKɎgėǂłB
̃\tg̎gpɂĐvɂāA҂͈ؐӔC܂B

Tv

QR}hsł悤ɂȂ܂B
f+j  end-of-line Ƃo悤ɂȂ܂B
emacskey-chord.el֗ƕč܂A
\[X͌ĂȂ̂ŎdlECZXɌ݊͂܂B



(require "key-chord")
(add-hook '*pre-command-hook* 'key-chord)
.xyzzyɂł܂B
̃t@C~/site-lispɓăoCgRpC܂B
netinstallerpăCXg[Ȃ炱܂ł͕svłB

.xyzzy
(define-key-chord '(#\f #\j) 'end-of-line)
Ƃ܂BWł͉o^ĂȂ̂ŁADȂo^܂B
.xyzzy]Ύg܂B

ݒ

͂̎tԂ *key-chord-interval* ŕύXł܂B
msPʂŋLq܂BW16msłB
tL[ *key-chord-keys* ɃXgŋLq܂B
ɓo^ꂽL[ɔ܂BWłqwerty1L[͂ł镶łB
VtgKvȃL[t@NVL[ǉł܂A
tL[͘Aē͂ƃJNJN悤ɂȂ܂B
toggle-key-chordkey-chord̎gp؂ւ̂ŁAgƂgȂǂB

todo

R}hꗗ\
[hɃR}ho^


001 2009-01-03 18:52 łB

I|#

(defvar *key-chord-keys* (coerce "1234567890-^\\qwertyuiop@[asdfghjkl;:]zxcvbnm,./" 'list))
(defvar *key-chord-map* nil)
(defvar *key-chord-interval* 16)

(export '(toggle-key-chord define-key-chord))

(defun key-chord ()
  "QR}hsłB"
  (let ((time (get-internal-real-time))
		(a (svref (get-recent-keys) (1- (length (get-recent-keys)))))
		c cmd)
	(when (find a *key-chord-keys*)
	  (while (not (or (setq c (read-char-no-hang *keyboard*))
					  (> (- (get-internal-real-time) time) *key-chord-interval*))))
	  (and a c
		   (setq cmd (find-combination (list a c) *key-chord-map* :prd 'char< :test 'equal :key 'car))
		   (setq *this-command* (cadr cmd)))
	  (if (and (not cmd) c) (progn (unread-char c) (refresh-screen))))))

(defun toggle-key-chord (&optional (tgl 0))
  "͂؂ւB"
  (interactive)
  (if (numberp tgl)
	  (if (find 'key-chord *pre-command-hook*)
		  (toggle-key-chord nil)
		(toggle-key-chord t))
	(if (eq tgl t)
		(add-hook '*pre-command-hook* 'key-chord)
	  (delete-hook '*pre-command-hook* 'key-chord))))

(defun find-combination (keys sorted-lst &key (prd '<) (test 'equal) (key 'identity))
  "\[gĂTB"
  (find (stable-sort keys prd) sorted-lst :test test :key key))

(defun define-key-chord (keys cmd)
  "QR}ho^B"
  (unless (find-combination #1=(list (car keys) (cadr keys)) *key-chord-map* :prd 'char< :test 'equal :key 'car)
	(push (list (stable-sort #1# 'char<) cmd)
			 *key-chord-map*)))

;end of file key-chord.l